package something;

import java.io.*;
import java.util.Scanner;

import jxl.Cell;
import jxl.Sheet;
import jxl.Workbook;
import jxl.read.biff.BiffException;
import jxl.write.Label;
import jxl.write.Number;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;

public class SplitStrings{
 
 static int num_sheets = new File("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\YT").list().length; 
 
 @SuppressWarnings("resource")
 public static int countLines(String file) throws IOException {
  BufferedReader reader = new BufferedReader(new FileReader(file));
  int lines = 0;
  while (reader.readLine() != null) lines++;
     return lines;
 } 
 
 @SuppressWarnings("resource")
 public static String[] stemWords(String filename) throws IOException{ 
  String[] stemmedWords = new String[countLines(filename)];
  InputStream file = new FileInputStream(filename);
  char[] w = new char[501];
  Stemmer s = new Stemmer();
       for (int i = 0; i < 1; i++){  
        int x = 0;
            while(true){  
             int ch = file.read();
             if (Character.isLetter((char) ch)){
              int j = 0;
              while(true){  
              ch = Character.toLowerCase((char) ch);
                       w[j] = (char) ch;
                       if (j < 500) j++;
                       ch = file.read();
                       if (!Character.isLetter((char) ch)){
                          for (int c = 0; c < j; c++) s.add(w[c]); 
                           s.stem();
                           {  
                            String u;

                            u = s.toString();
                            stemmedWords[x] = u;
                            //print words to test function
                            //System.out.println(u);
                            x++;
                          }
                         break;
                       }
              }
             }
                if (ch < 0) break;
                //System.out.print((char)ch);
           }
      }
  return stemmedWords;
 }
            
 @SuppressWarnings("resource")
 public static void parseFiles(Workbook wkbk) throws BiffException, IOException, RowsExceededException, WriteException{
  String[] file_names = getCol(wkbk, 0,0);
  String YT = "C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\YT\\"+file_names[0]+".srt";
  String Coursera = "C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\Coursera\\"+file_names[0]+".srt";
  
  int row1 = 1;
  WritableWorkbook wworkbook = Workbook.createWorkbook(new File("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\parsed_files.xls"));
 
  Label label = new Label(0, 0, "YT");
  Label label2 = new Label(1, 0, "Coursera");

  Scanner sc = new Scanner(new File(YT));
  Scanner sc2 = new Scanner(new File(Coursera));
  
  for(int m = 0; m < file_names.length; m++){
   WritableSheet result_sheet = wworkbook.createSheet("Vid"+m,0);
   if(m == 0){
    result_sheet.addCell(label);
    result_sheet.addCell(label2);
   }
   
   YT = "C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\YT\\"+file_names[0]+".srt";
   Coursera = "C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\Coursera\\"+file_names[0]+".srt";
   YT = "C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\YT\\"+file_names[m]+".srt";
   Coursera = "C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\Coursera\\"+file_names[m]+".srt";
      
   sc = new Scanner(new File(YT));
   sc2 = new Scanner(new File(Coursera));
   file_names[m] = result_sheet.getCell(0, m).getContents().toString();
  
   //get YT words
   row1=1; //set row to 1 so words get printed under the titles
      while (sc.hasNextLine()) {
    Scanner s = new Scanner(sc.nextLine());
    @SuppressWarnings("unused")
    boolean b;
    
          //read and write for the first file
          while (b = s.hasNext()) {
              String str = s.next();
              if(!str.matches(".*\\d.*") && !str.matches("-->")){
               String word = str.replace(",","");
               String word2 = word.replace(".","");
               String word3 = word2.replace("'","");
               String word4 = word3.replace(":","");
               String word5 = word4.replace(" ","");
               Label YT_CC = new Label(0, row1, word5);
               result_sheet.addCell(YT_CC);
      row1++;
              }
          }
      }


   
      //get Coursera words
      row1=1;
     while (sc2.hasNextLine()) {
    Scanner s2 = new Scanner(sc2.nextLine());
          @SuppressWarnings("unused")
    boolean b;
          //read and write for the second file
          while (b = s2.hasNext()) {
              String str = s2.next();
              if(!str.matches(".*\\d.*") && !str.matches("-->")){
               String word = str.replace(",","");
               String word2 = word.replace(".","");
               String word3 = word2.replace("'","");
               String word4 = word3.replace(":","");
               String word5 = word4.replace(" ","");
               Label Coursera_CC = new Label(1, row1, word5);
               result_sheet.addCell(Coursera_CC);           
      row1++;
              }
          }
      }
  }
  wworkbook.write();
  wworkbook.close();
 }

 public static String[] getCol(Workbook wkbk, int col, int which_sheet){
  int row_num = 0;
  Sheet sheet = wkbk.getSheet(which_sheet);
  int size = sheet.getRows();
  String[] row_words = new String[size];
  
  for(int i=0; i < size; i++){
   row_words[i] = sheet.getCell(col, row_num).getContents();
   row_num++;
  }
  return row_words;
 }
 
 public static String[] getCol(WritableWorkbook wkbk, int col, int which_sheet){
  int row_num = 1;
  Sheet sheet = wkbk.getSheet(which_sheet);
  int size = sheet.getRows();
  String[] row_words = new String[size];
  
  for(int i=0; i < size; i++){
   row_words[i] = sheet.getCell(col, row_num).getContents();
   row_num++;
  }
  return row_words;
 }
 
 public static void unigram() throws BiffException, IOException, RowsExceededException, WriteException{
  Integer result_row = 1, word_count = 0, tech_word_count = 0, norm_word_count = 0, func_word_count = 0, total_word_count = 0,
    total_func_YT_count = 0, total_func_C_count = 0, total_norm_YT_count = 0, total_norm_C_count = 0, total_tech_YT_count = 0, total_tech_C_count = 0;
  String type = new String(), accS = new String();
  double tech_YT_count = 0, tech_C_count = 0, norm_YT_count = 0, norm_C_count = 0,func_YT_count = 0, func_C_count = 0, YT_acc = 0, Coursera_acc = 0, acc = 0; //count vars
  Number tech_YT_result, tech_C_result, norm_YT_result, norm_C_result, func_YT_result, func_C_result; //will contain value and cell to write value to
  
  /*****Constant******/
  //file containing video names
  Workbook vids = Workbook.getWorkbook(new File("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\vid_names.xls"));  
  //excel file to read from
  Workbook parsed_files = Workbook.getWorkbook(new File("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\parsed_files.xls"));
  //excel file to write to
  WritableWorkbook uni_results_file = Workbook.createWorkbook(new File("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\unigram_results.xls"));
  
  //string containing video names 
  String[] vid_files = getCol(vids,0,0);
  
  String[] tech_terms_to_compare = stemWords("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\techterms.txt"); //string containing technical terms
  String[] norm_terms_to_compare = stemWords("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\normterms.txt"); //string containing normal terms
  String[] func_terms_to_compare = stemWords("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\Closed_Captioning\\functerms.txt"); //string containing function terms
  /******Constant*******/
  
  WritableSheet uni_results_sheet = null;
  WritableSheet agg_results_sheet = uni_results_file.createSheet("Aggregated Results",0);
  
  //loop while there is a file to read from
  for(int v = 0; v < vid_files.length; v++){
   Label l1 = new Label(0,0,"Term"),l2 = new Label(1,0,"YT"),l3 = new Label(2,0,"Coursera"), l4 = new Label(3,0,"Type"), l7 = new Label(4,0,"Accuracy"),
     l9 = new Label(5,0,"Total Accuracy"), l11 = new Label(6,0,"Func Word Count"), l12 = new Label(7,0,"Norm Word Count"), 
     l13 = new Label(8,0,"Tech Word Count"), l14 = new Label(9,0,"Total Word Count");
   Label l5,l6,l8 = null;
   result_row = 1; //reset results_row
   String[] YT_words = getCol(parsed_files,0,v); //string containing YT parsed words
   String[] Coursera_words = getCol(parsed_files,1,v); //string containing Coursera parsed words  
   uni_results_sheet = uni_results_file.createSheet("Results"+v,0);
   int i=0;
   //create columns for Unigram table
   
   
   //print labels on technical words sheet
   uni_results_sheet.addCell(l1);
   uni_results_sheet.addCell(l2);
   uni_results_sheet.addCell(l3);
   uni_results_sheet.addCell(l4);
   uni_results_sheet.addCell(l7);
   uni_results_sheet.addCell(l9);
   uni_results_sheet.addCell(l11);
   uni_results_sheet.addCell(l12);
   uni_results_sheet.addCell(l13);
   uni_results_sheet.addCell(l14);
   
   //check files for tech words
   for(String term : tech_terms_to_compare){
    for(String parsed_word : YT_words){
     if(parsed_word.contains(term)){
      tech_YT_count++;
      total_tech_YT_count++;
     }
    }
    for(String parsed_word : Coursera_words){
     if(parsed_word.contains(term)){
      tech_C_count++;
      total_tech_C_count++;
     }
    }
    
    type="technical"; 
    l5 = new Label(0,result_row,tech_terms_to_compare[i]); //print terms in unigram excel doc
    uni_results_sheet.addCell(l5);
    tech_YT_result = new Number(1,result_row, tech_YT_count); //add count of the word from YT
    uni_results_sheet.addCell(tech_YT_result);
    tech_C_result = new Number(2,result_row, tech_C_count); //add count of the word from Coursera
    uni_results_sheet.addCell(tech_C_result);
    l6 = new Label(3,result_row,type); //print type of word
    uni_results_sheet.addCell(l6);
    
    /***************** accuracy ******************/
    YT_acc = Double.parseDouble(uni_results_sheet.getCell(1, result_row).getContents()); //YT accuracy
    Coursera_acc = Double.parseDouble(uni_results_sheet.getCell(2, result_row).getContents()); //Coursera accuracy
    acc = YT_acc/Coursera_acc;
    accS = Double.toString(acc); //convert acc from double to String
    l8 = new Label(4,result_row,accS); //print in 4th col of sheet
    uni_results_sheet.addCell(l8);
    
    result_row++;
    i++;
    tech_word_count++;
    tech_C_count = 0;
    tech_YT_count = 0;
   }
   
   l8 = new Label(6,1,tech_word_count.toString());
   uni_results_sheet.addCell(l8);
   i=0;
   
   //check files for norm words
   for(String term : norm_terms_to_compare){
    for(String parsed_word : YT_words){
     if(parsed_word.contains(term)){
      norm_YT_count++;
      total_norm_YT_count++;
     }
    }
    for(String parsed_word : Coursera_words){
     if(parsed_word.contains(term)){
      norm_C_count++;
      total_norm_C_count++;
     }
    }    
    type="normal";
    l5 = new Label(0,result_row,norm_terms_to_compare[i]); //print terms in unigram excel doc
    uni_results_sheet.addCell(l5);
    norm_YT_result = new Number(1,result_row, norm_YT_count); //add count of the word from YT
    uni_results_sheet.addCell(norm_YT_result);
    norm_C_result = new Number(2,result_row, norm_C_count); //add count of the word from Coursera
    uni_results_sheet.addCell(norm_C_result);
    l6 = new Label(3,result_row,type); //print type of word
    uni_results_sheet.addCell(l6);
    
    /**************** accuracy **********************/
    YT_acc = Double.parseDouble(uni_results_sheet.getCell(1, result_row).getContents()); //YT accuracy
    Coursera_acc = Double.parseDouble(uni_results_sheet.getCell(2, result_row).getContents()); //Coursera accuracy
    acc = YT_acc/Coursera_acc;
    accS = Double.toString(acc); //convert acc from double to String
    l8 = new Label(4,result_row,accS); //print in 4th col of sheet
    uni_results_sheet.addCell(l8);
    
    result_row++;
    i++;
    norm_word_count++;
    norm_C_count = 0;
    norm_YT_count = 0;
   }
   l8 = new Label(7,1,norm_word_count.toString());
   uni_results_sheet.addCell(l8);
   i=0;
   
   //check files for func words
   for(String term : func_terms_to_compare){
    for(String parsed_word : YT_words){
     if(parsed_word.contains(term)){
      func_YT_count++;
      total_func_YT_count++;
     }
    }
    for(String parsed_word : Coursera_words){
     if(parsed_word.contains(term)){
      func_C_count++;
      total_func_C_count++;
     }
    }    
    type="function";
    l5 = new Label(0,result_row,func_terms_to_compare[i]); //print terms in unigram excel doc
    uni_results_sheet.addCell(l5);
    func_YT_result = new Number(1,result_row, func_YT_count); //add count of the word from YT
    uni_results_sheet.addCell(func_YT_result);
    func_C_result = new Number(2,result_row, func_C_count); //add count of the word from Coursera
    uni_results_sheet.addCell(func_C_result);
    l6 = new Label(3,result_row,type); //print type of word
    uni_results_sheet.addCell(l6);
    
    /**************** accuracy **********************/
    YT_acc = Double.parseDouble(uni_results_sheet.getCell(1, result_row).getContents()); //YT accuracy
    Coursera_acc = Double.parseDouble(uni_results_sheet.getCell(2, result_row).getContents()); //Coursera accuracy
    acc = YT_acc/Coursera_acc;
    accS = Double.toString(acc); //convert acc from double to String
    l8 = new Label(4,result_row,accS); //print in 4th col of sheet
    uni_results_sheet.addCell(l8);
    
    result_row++;
    func_word_count++;
    i++;
    func_C_count = 0;
    func_YT_count = 0;
   }
   
   l8 = new Label(8,1,func_word_count.toString());
   uni_results_sheet.addCell(l8);
   
   /*********** get total accuracy *****************/
   Label l10 = null;
   Double temp_acc = 0.0, acc_final = 0.0, total = 0.0;
   String print = new String();
   Cell[] stuff = uni_results_sheet.getColumn(4);
   for(Cell c : stuff){
    if(c.getContents().matches("^-?\\d*\\.\\d+$")){ 
     temp_acc = Double.valueOf(c.getContents()) + temp_acc;
     total++;
    }      
   }
   acc_final = temp_acc/total;
   print = acc_final.toString();
   //System.out.println(print);
   l10 = new Label(5,1,print);
   uni_results_sheet.addCell(l10);
   total = 0.0; temp_acc = 0.0;
 } 
 total_word_count = func_word_count+norm_word_count+tech_word_count;
 Label lab = new Label(9,1,total_word_count.toString());
 uni_results_sheet.addCell(lab);
 
 Label term_lab = new Label(0,0, "Term"), YT_term_lab = new Label(1,0, "YT"), C_term_lab = new Label(2,0, "Coursera"), type_lab = new Label(3,0, "Type");
 Label  YT_tot_count_lab,  C_tot_count_lab, agg_type_lab, agg_term_lab = null;
 agg_results_sheet.addCell(term_lab);
 agg_results_sheet.addCell(YT_term_lab);
 agg_results_sheet.addCell(C_term_lab);
 agg_results_sheet.addCell(type_lab);
 
 String YT_word = new String(), C_word = new String(), agg_type = new String(), agg_term = new String();
 Integer YT_tot_count = 0, C_tot_count = 0;
 int length = uni_results_file.getSheet(4).getRows();
 
 for(int j = 1; j < length; j++){
  for(int count = 0; count < uni_results_file.getSheets().length-1; count++){
   agg_term = uni_results_file.getSheet(count).getCell(0, j).getContents();
   YT_word = uni_results_file.getSheet(count).getCell(1, j).getContents();
   C_word = uni_results_file.getSheet(count).getCell(2, j).getContents();
   agg_type = uni_results_file.getSheet(count).getCell(3, j).getContents();
   
   YT_tot_count = Integer.parseInt(YT_word) + YT_tot_count;
   C_tot_count = Integer.parseInt(C_word) + C_tot_count;
 
   agg_term_lab = new Label(0, j, agg_term);
   YT_tot_count_lab = new Label(1, j, YT_tot_count.toString());
   C_tot_count_lab = new Label(2, j, C_tot_count.toString());
   agg_type_lab = new Label(3, j, agg_type);
   
   agg_results_sheet.addCell(C_tot_count_lab);
   agg_results_sheet.addCell(YT_tot_count_lab);
   agg_results_sheet.addCell(agg_type_lab);
   agg_results_sheet.addCell(agg_term_lab);
  }
 }
  
 uni_results_file.write();
 uni_results_file.close();
 }
 
 public static void main(String[] args) throws RowsExceededException, WriteException, BiffException, IOException{
   
    //file to pass in to parseFile function
  Workbook wkbk = Workbook.getWorkbook(new File("C:\\Users\\Phillip\\Documents\\Phil\\Phil\\MQP\\vid_names.xls"));
  
   parseFiles(wkbk);
   unigram();
   System.out.println("Program is done");
       }
      }